
#ifndef GAMEMANAGER_H_INCLUDED
#define GAMEMANAGER_H_INCLUDED

class GameManager {

 public:

	// the viewport
	Viewport *viewport;

	// the road instance
	Road *road;

	// the sprite manager
	SpriteManager *spriteManager;

	// the HUD
	HUD *hUD;

	// the player car
	Car *carPlayer;

	// the current lap time (ms)
	int lapTimeCurrent;

	// the best lap time (ms)
	int lapTimeBest;

	// the current lap
	int lap;

 public:

	GameManager(void);
	~GameManager(void);

	// init the hardware to run the game
	void init(void);

	// set the view size, and do some precalculations
	void precalculateScreen(int viewDX, int viewDY);

	// the main loop iteration of the game
	void iteration(int deltaTime, int keysCurrent, int keysOld);

	// draw the screen
	void draw(void);

	// reset the game
	void reset(void);
};

#endif
